################################################################################
# @ Author       : Wenyan Huo
# @ Email        : huowenyan0616@126.com
# @ Encoding     : UTF-8
# @ Language     : Python
# @ Date         : 2022-04-02 00:01
# @ LastEditTime : 2022-09-09 15:17
# @ 'E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code' was the storage location of script, raw data, and results.
################################################################################

import zipfile
import os
from os import path
from typing import TextIO

## Unzip the "taxonomy.qzv" and "3.table_trim_16.qzv" files of  ASVs data results
dir_path1 = "E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/1_taxonomy"
os.makedirs(dir_path1, exist_ok=True)
ASV_Results_file = os.listdir('0_ASVs_Results')
for ASV_Results_f in ASV_Results_file:
    ASV_Results_F = str(ASV_Results_f)
    print(ASV_Results_F)
    ASV_Results_f1 = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/0_ASVs_Results',
                               ASV_Results_f)
    ASV_Results_f2 = path.join(ASV_Results_f1, 'taxonomy.qzv')
    ASV_Results_f3 = path.join(ASV_Results_f1, '3.table_trim_16.qzv')
    ASV_Results_ff1 = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/1_taxonomy',
                                ASV_Results_f)
    if os.path.exists(ASV_Results_f2):
        z = zipfile.ZipFile(ASV_Results_f2, 'r')
        z.extractall(path=ASV_Results_ff1)
    ASV_Results_ff2 = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/1_table',
                                ASV_Results_f)
    if os.path.exists(ASV_Results_f3):
        z = zipfile.ZipFile(ASV_Results_f3, 'r')
        z.extractall(path=ASV_Results_ff2)


## Extract 'metadata.tsv'file from the folder '1_taxonomy' to folder '2_taxonomy' and rename it.
dir_path2_taxonomy = "E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/2_taxonomy"
os.makedirs(dir_path2_taxonomy, exist_ok=True)
taxonomy_1_file = os.listdir('1_taxonomy')
for taxonomy_1_f in taxonomy_1_file:
    taxonomy_1_F = str(taxonomy_1_f)
    print(taxonomy_1_F)
    taxonomy_1_FF1 = taxonomy_1_F + '_taxonomy.tsv'
    taxonomy_1_f1 = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/1_taxonomy',
                              taxonomy_1_f)
    taxonomy_1_file1 = os.listdir(taxonomy_1_f1)
    for taxonomy_1_ff1 in taxonomy_1_file1:
        taxonomy_1_F1 = str(taxonomy_1_ff1)
        print(taxonomy_1_F1)
        taxonomy_1_f2 = path.join(taxonomy_1_f1, taxonomy_1_ff1)
        taxonomy_1_f3 = path.join(taxonomy_1_f2, 'data')
        taxonomy_1_f4 = path.join(taxonomy_1_f3, 'metadata.tsv')
        os.rename(taxonomy_1_f4,
                  os.path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/2_taxonomy',
                               taxonomy_1_FF1))


## Extract 'metadata.tsv'file from the folder '1_table' to folder '2_table' and rename it.
dir_path2_table = "E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/2_table"
os.makedirs(dir_path2_table, exist_ok=True)
table_1_file = os.listdir('1_table')
for table_1_f in table_1_file:
    table_1_F = str(table_1_f)
    print(table_1_F)
    table_1_FF1 = table_1_F + '_table.tsv'
    table_1_f1 = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/1_table', table_1_f)
    table_1_file1 = os.listdir(table_1_f1)
    for table_1_ff1 in table_1_file1:
        table_1_F1 = str(table_1_ff1)
        print(table_1_F1)
        table_1_f2 = path.join(table_1_f1, table_1_ff1)
        table_1_f3 = path.join(table_1_f2, 'data')
        table_1_f4 = path.join(table_1_f3, 'metadata.tsv')
        os.rename(table_1_f4,
                  os.path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/2_table', table_1_FF1))


## Transpose the data in the "*_table.tsv" files in the "2_table" folder.
dir_path3_table = "E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/3_table_transpose"
os.makedirs(dir_path3_table, exist_ok=True)

transpose_2_file = os.listdir('2_table')
for transpose_2_F in transpose_2_file:
    transpose_2_F1 = str(transpose_2_F)
    print(transpose_2_F1)
    transpose_2_F1_1 = str(transpose_2_F1.rstrip('.tsv'))
    transpose_2_F1_2 = transpose_2_F1_1 + '.txt'
    transpose_2_F1_3 = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/3_table_transpose',
                                 transpose_2_F1_2)
    transpose_2_F1_4 = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/2_table',
                                 transpose_2_F1)
    transpose_2_f2 = open(transpose_2_F1_3, 'a+', encoding='utf-8')
    transpose_2_f1 = open(transpose_2_F1_4, 'r', encoding='utf-8')
    transpose_2_lines = transpose_2_f1.readlines()
    transpose_2_L0 = transpose_2_lines[0].rstrip('\n')
    transpose_2_L2 = transpose_2_lines[2].rstrip('\n')
    print(transpose_2_L0)
    print(transpose_2_L2)
    transpose_2_S0 = transpose_2_L0.split('	')
    transpose_2_S2 = transpose_2_L2.split('	')
    print(len(transpose_2_S0))
    print(len(transpose_2_S2))
    i = 0
    for i in range(len(transpose_2_S0)):
        transpose_2_LL = transpose_2_S0[i] + '	' + transpose_2_S2[i]
        transpose_2_f2.writelines(transpose_2_LL + '\n')
        i += 1
    transpose_2_f2.close()
    transpose_2_f1.close()



##Remove the ASV of the host in all "*_taxonomy.tsv" files in the "2_taxonomy" folder based on the host classification information in the "3_Hostlist" file.
dir_path4_taxonomy = "E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/4_taxonomy"
os.makedirs(dir_path4_taxonomy, exist_ok=True)

taxonomy4_OHL = open('3_Hostlist.txt', 'r', encoding='utf-8')
taxonomy4_OHL_lines = taxonomy4_OHL.readlines()
for taxonomy4_OHL_L in taxonomy4_OHL_lines:
    taxonomy4_OHL_N = str(taxonomy4_OHL_L)
    taxonomy4_OHL_NN = taxonomy4_OHL_N.split('	')
    taxonomy4_OHL_N1 = str(taxonomy4_OHL_NN[0])
    taxonomy4_OHL_N1_1 = taxonomy4_OHL_N1 + '_taxonomy.tsv'
    taxonomy4_OHL_N2 = str(taxonomy4_OHL_NN[1])
    taxonomy4_OHL_N2_1 = taxonomy4_OHL_N2.rstrip('\n')
    taxonomy4_ff = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/2_taxonomy',
                             taxonomy4_OHL_N1_1)
    taxonomy4_fff = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/4_taxonomy',
                              taxonomy4_OHL_N1_1)
    taxonomy4_ff1 = open(taxonomy4_ff, 'r', encoding='utf-8')
    taxonomy4_fff1 = open(taxonomy4_fff, 'a+', encoding='utf-8')
    taxonomy4_ff1_lines = taxonomy4_ff1.readlines()
    for taxonomy4_ff1_L in taxonomy4_ff1_lines:
        taxonomy4_ff1_N = str(taxonomy4_ff1_L)
        taxonomy4_ff1_NN = taxonomy4_ff1_N.split('	')
        taxonomy4_ff1_N1 = str(taxonomy4_ff1_NN[0])
        taxonomy4_ff1_N2 = str(taxonomy4_ff1_NN[1])
        if ';s__' in taxonomy4_OHL_N2_1:
            if taxonomy4_ff1_N2.find(taxonomy4_OHL_N2_1) == -1:
                print(taxonomy4_OHL_N2_1)
                taxonomy4_fff1.writelines(taxonomy4_ff1_N)
        else:
            if taxonomy4_OHL_N2_1 != taxonomy4_ff1_N2:
                print(taxonomy4_OHL_N2_1)
                taxonomy4_fff1.writelines(taxonomy4_ff1_N)
    taxonomy4_ff1.close()
    taxonomy4_fff1.close()
taxonomy4_OHL.close()


##  Based on the ASV information in the "_taxonomy.tsv" files in the "4_taxonomy" folder, remove the host ASV from the "_table.txt" files in the "3_table_transpose" folder.
dir_path4_table = "E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/4_table"
os.makedirs(dir_path4_table, exist_ok=True)
table4_file_Taxon = os.listdir('4_taxonomy')
for table4_f_Taxon in table4_file_Taxon:
    table4_F_Taxon = str(table4_f_Taxon)
    table4_F_Taxon1 = str(table4_F_Taxon.rstrip('_taxonomy.tsv'))
    table4_F_Taxon2 = table4_F_Taxon1 + '_table.txt'
    table4_fff = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/4_table', table4_F_Taxon2)
    table4_fff1 = open(table4_fff, 'a+', encoding='utf-8')
    table4_ff = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/4_taxonomy', table4_F_Taxon)
    table4_ff1 = open(table4_ff, 'r', encoding='utf-8')
    table4_ff1_lines = table4_ff1.readlines()
    for table4_ff1_L in table4_ff1_lines:
        table4_ff1_N = str(table4_ff1_L)
        table4_ff1_NN = table4_ff1_N.split('	')
        table4_ff1_N1 = str(table4_ff1_NN[0])
        print(table4_ff1_N1)
        table4_f = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/3_table_transpose',
                             table4_F_Taxon2)
        table4_f1 = open(table4_f, 'r', encoding='utf-8')
        table4_f1_lines = table4_f1.readlines()
        for table4_f1_L in table4_f1_lines:
            table4_f1_N = str(table4_f1_L)
            print(table4_f1_N)
            if table4_f1_N.find(table4_ff1_N1) != -1:
                table4_fff1.writelines(table4_f1_N)
        table4_f1.close()
    table4_fff1.close()
    table4_ff1.close()

## Add headers ("id" + "Sample number") to all "*_table.txt" files in the "4_table" folder.
dir_path5_table = "E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/5_table_AddHeader"
os.makedirs(dir_path5_table, exist_ok=True)
table5_file_Table = os.listdir('4_table')
for table5_f_Table in table5_file_Table:
    table5_F_Table = str(table5_f_Table)
    table5_F_Table1 = str(table5_F_Table.rstrip('_table.txt'))
    table5_fff = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/5_table_AddHeader',
                           table5_F_Table)
    table5_fff1 = open(table5_fff, 'a+', encoding='utf-8')
    table5_fff1.writelines('id' + '	' + table5_F_Table1 + '\n')
    table5_ff = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/4_table', table5_F_Table)
    table5_ff1 = open(table5_ff, 'r', encoding='utf-8')
    table5_ff1_lines = table5_ff1.readlines()
    for table5_ff1_L in table5_ff1_lines:
        table5_ff1_N = str(table5_ff1_L)
        print(table5_ff1_N)
        table5_fff1.writelines(table5_ff1_N)
    table5_fff1.close()
    table5_ff1.close()

## Merge all data from "*-table.txt" files in the "5_table_AddHeader" folder into one file named "6_table".
merge_table_temp1 = open('6_table_temp1.txt','a+',encoding='utf-8')
merge_table_temp2 = open('6_table_temp2.txt','a+',encoding='utf-8')
merge_table_file = os.listdir('5_table_AddHeader')
merge_table_h = 'id' + '	'
merge_table_Num_f = 1
for merge_table_F in merge_table_file:
    merge_table_ff = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/5_table_AddHeader',str(merge_table_F))
    merge_table_ff1: TextIO = open(merge_table_ff,'r', encoding = 'utf-8')
    merge_table_lines = merge_table_ff1.readlines()
    print(merge_table_lines[1])
    merge_table_H = str(merge_table_lines[0])
    merge_table_H1 = merge_table_H.split('	')
    merge_table_H1_1 = str(merge_table_H1[1])
    merge_table_H1_2 = merge_table_H1_1.rstrip('\n') + '	'
    merge_table_h = merge_table_h + merge_table_H1_2
    merge_table_temp1.writelines(merge_table_h + '\n')
    for i in range(1,len(merge_table_lines)):
        merge_table_LL = str(merge_table_lines[i])
        merge_table_LL_1 = merge_table_LL.split('	')
        merge_table_LL_1_1 = str(merge_table_LL_1[0])
        merge_table_LL_1_2 = str(merge_table_LL_1[1])
        merge_table_LL_1_3 = str(merge_table_LL_1_2.rstrip('\n'))
        j = 1
        for j in range(j,merge_table_Num_f):
            merge_table_LL_1_1 = merge_table_LL_1_1  + '	' + '0'
            j = j + 1
        merge_table_LL_1_1 = merge_table_LL_1_1 + '	' + merge_table_LL_1_3
        jj = 1
        merge_table_Num_f_yu = 280-merge_table_Num_f
        ## 280 is the number of samples.
        for jj in range(merge_table_Num_f_yu):
            merge_table_LL_1_1 = merge_table_LL_1_1 + '	' + '0'
            jj += 1
        i = i + 1
        merge_table_temp2.writelines(merge_table_LL_1_1 + '\n')
    merge_table_Num_f += 1
    merge_table_ff1.close()
merge_table_temp2.close()
merge_table_temp1.close()

merge_table = open('6_table.txt','a+',encoding='utf-8')
with open('6_table_temp1.txt', 'r', encoding='utf-8') as file_H:  
    line_count = 0    
    for line in file_H:  
        line_count += 1    
        if line_count == 280:  
        	## 280 is the number of samples.
            print(line)
            merge_table.writelines(line)
            break
file_H.close()
with open('6_table_temp2.txt', 'r', encoding='utf-8') as file_table:
    for line in file_table:
        print(line)
        merge_table.writelines(line)
file_table.close()
merge_table.close()

## Merge all data from "*_taxonomy.tsv" files in the "4_taxonomy" folder into one file named "6_taxonomy"
merge_taxonomy6_temp = open('6_taxonomy_temp.txt','a+',encoding='utf-8')
file = os.listdir('4_taxonomy')
for F in file:
    ff = path.join('E:/01微生物研究所/10-数据/01-野外大型真菌资源调查/高通量测序/2022年5月-数据处理/Code/4_taxonomy', str(F))
    ff1 = open(ff,'r', encoding = 'utf-8')
    lines = ff1.readlines()
    for L in lines:
        L1 = str(L)
        L2 = L1.split('	')
        L2_1 = str(L2[0])
        L2_2 = str(L2[1])
        L2_3 = str(L2[2])
        if "k__" in L2_2 and "p__" in L2_2 and "c__" in L2_2 and "o__" in L2_2 and "f__" in L2_2 and "g__" in L2_2 and "s__" in L2_2:
            L3 = L2_2.split(';')
            L3_k = str(L3[0])
            if 'Incertae_sedis' in L3_k:
                L3_K = 'NA'
            L3_p = str(L3[1])
            if 'Incertae_sedis' in L3_p:
                L3_p = 'NA'
            L3_c = str(L3[2])
            if 'Incertae_sedis' in L3_c:
                L3_c = 'NA'
            L3_o = str(L3[3])
            if 'Incertae_sedis' in L3_o:
                L3_o = 'NA'
            L3_f = str(L3[4])
            if 'Incertae_sedis' in L3_f:
                L3_f = 'NA'
            L3_g = str(L3[5])
            if 'Incertae_sedis' in L3_g:
                L3_g = 'NA'
            L3_s = str(L3[6])
            if 'Incertae_sedis' in L3_s:
                L3_s = 'NA'
            else:
                L5 = L3_s.split('_')
                L6 = str(L5[3])
                print(L6)
                L3_s = 's__'+L6
            LL = L2_1 + '	' + L3_k + '	'+ L3_p + '	'+ L3_c + '	'+ L3_o + '	'+ L3_f + '	'+ L3_g + '	'+ L3_s
            merge_taxonomy6_temp.writelines(LL + '\n')
        if "k__" in L2_2 and "p__" in L2_2 and "c__" in L2_2 and "o__" in L2_2 and "f__" in L2_2 and "g__" in L2_2 and L2_2.find('s__')==-1:
            L3 = L2_2.split(';')
            L3_k = str(L3[0])
            if 'Incertae_sedis' in L3_k:
                L3_K = 'NA'
            L3_p = str(L3[1])
            if 'Incertae_sedis' in L3_p:
                L3_p = 'NA'
            L3_c = str(L3[2])
            if 'Incertae_sedis' in L3_c:
                L3_c = 'NA'
            L3_o = str(L3[3])
            if 'Incertae_sedis' in L3_o:
                L3_o = 'NA'
            L3_f = str(L3[4])
            if 'Incertae_sedis' in L3_f:
                L3_f = 'NA'
            L3_g = str(L3[5])
            if 'Incertae_sedis' in L3_g:
                L3_g = 'NA'
            L3_s = 's__'
            LL = L2_1 + '	' + L3_k + '	'+ L3_p + '	'+ L3_c + '	'+ L3_o + '	'+ L3_f + '	'+ L3_g + '	'+ L3_s
            merge_taxonomy6_temp.writelines(LL + '\n')
        if "k__" in L2_2 and "p__" in L2_2 and "c__" in L2_2 and "o__" in L2_2 and "f__" in L2_2 and L2_2.find('g__')==-1 and L2_2.find('s__')==-1:
            L3 = L2_2.split(';')
            L3_k = str(L3[0])
            if 'Incertae_sedis' in L3_k:
                L3_K = 'NA'
            L3_p = str(L3[1])
            if 'Incertae_sedis' in L3_p:
                L3_p = 'NA'
            L3_c = str(L3[2])
            if 'Incertae_sedis' in L3_c:
                L3_c = 'NA'
            L3_o = str(L3[3])
            if 'Incertae_sedis' in L3_o:
                L3_o = 'NA'
            L3_f = str(L3[4])
            if 'Incertae_sedis' in L3_f:
                L3_f = 'NA'
            L3_g = 'g__'
            L3_s = 's__'
            LL = L2_1 + '	' + L3_k + '	'+ L3_p + '	'+ L3_c + '	'+ L3_o + '	'+ L3_f + '	'+ L3_g + '	'+ L3_s
            merge_taxonomy6_temp.writelines(LL + '\n')
        if "k__" in L2_2 and "p__" in L2_2 and "c__" in L2_2 and "o__" in L2_2 and L2_2.find('f__')==-1 and L2_2.find('g__')==-1 and L2_2.find('s__')==-1:
            L3 = L2_2.split(';')
            L3_k = str(L3[0])
            if 'Incertae_sedis' in L3_k:
                L3_K = 'NA'
            L3_p = str(L3[1])
            if 'Incertae_sedis' in L3_p:
                L3_p = 'NA'
            L3_c = str(L3[2])
            if 'Incertae_sedis' in L3_c:
                L3_c = 'NA'
            L3_o = str(L3[3])
            if 'Incertae_sedis' in L3_o:
                L3_o = 'NA'
            L3_f = 'f__'
            L3_g = 'g__'
            L3_s = 's__'
            LL = L2_1 + '	' + L3_k + '	'+ L3_p + '	'+ L3_c + '	'+ L3_o + '	'+ L3_f + '	'+ L3_g + '	'+ L3_s
            merge_taxonomy6_temp.writelines(LL + '\n')
        if "k__" in L2_2 and "p__" in L2_2 and "c__" in L2_2 and L2_2.find('o__')==-1 and L2_2.find('f__')==-1 and L2_2.find('g__')==-1 and L2_2.find('s__')==-1:
            L3 = L2_2.split(';')
            L3_k = str(L3[0])
            if 'Incertae_sedis' in L3_k:
                L3_K = 'NA'
            L3_p = str(L3[1])
            if 'Incertae_sedis' in L3_p:
                L3_p = 'NA'
            L3_c = str(L3[2])
            if 'Incertae_sedis' in L3_c:
                L3_c = 'NA'
            L3_o = 'o__'
            L3_f = 'f__'
            L3_g = 'g__'
            L3_s = 's__'
            LL = L2_1 + '	' + L3_k + '	'+ L3_p + '	'+ L3_c + '	'+ L3_o + '	'+ L3_f + '	'+ L3_g + '	'+ L3_s
            merge_taxonomy6_temp.writelines(LL + '\n')
        if "k__" in L2_2 and "p__" in L2_2 and L2_2.find('c__')==-1 and L2_2.find('o__')==-1 and L2_2.find('f__')==-1 and L2_2.find('g__')==-1 and L2_2.find('s__')==-1:
            L3 = L2_2.split(';')
            L3_k = str(L3[0])
            if 'Incertae_sedis' in L3_k:
                L3_K = 'NA'
            L3_p = str(L3[1])
            if 'Incertae_sedis' in L3_p:
                L3_p = 'NA'
            L3_c = 'c__'
            L3_o = 'o__'
            L3_f = 'f__'
            L3_g = 'g__'
            L3_s = 's__'
            LL = L2_1 + '	' + L3_k + '	'+ L3_p + '	'+ L3_c + '	'+ L3_o + '	'+ L3_f + '	'+ L3_g + '	'+ L3_s
            merge_taxonomy6_temp.writelines(LL + '\n')
        if "k__" in L2_2 and L2_2.find('p__')==-1 and L2_2.find('c__')==-1 and L2_2.find('o__')==-1 and L2_2.find('f__')==-1 and L2_2.find('g__')==-1 and L2_2.find('s__')==-1:
            L3 = L2_2.split(';')
            L3_k = str(L3[0])
            if 'Incertae_sedis' in L3_k:
                L3_K = 'NA'
            L3_p = 'p__'
            L3_c = 'c__'
            L3_o = 'o__'
            L3_f = 'f__'
            L3_g = 'g__'
            L3_s = 's__'
            LL = L2_1 + '	' + L3_k + '	'+ L3_p + '	'+ L3_c + '	'+ L3_o + '	'+ L3_f + '	'+ L3_g + '	'+ L3_s
            merge_taxonomy6_temp.writelines(LL + '\n')
        if L2_2.find('k__') == -1 and L2_2.find('p__')==-1 and L2_2.find('c__')==-1 and L2_2.find('o__')==-1 and L2_2.find('f__')==-1 and L2_2.find('g__')==-1 and L2_2.find('s__')==-1:
            L3_k = 'k__'
            L3_p = 'p__'
            L3_c = 'c__'
            L3_o = 'o__'
            L3_f = 'f__'
            L3_g = 'g__'
            L3_s = 's__'
            LL = L2_1 + '	' + L3_k + '	'+ L3_p + '	'+ L3_c + '	'+ L3_o + '	'+ L3_f + '	'+ L3_g + '	'+ L3_s
            merge_taxonomy6_temp.writelines(LL + '\n')
    ff1.close()
merge_taxonomy6_temp.close()

merge_taxonomy6 = open('6_taxonomy.txt','a+',encoding='utf-8')
O6tt = open('6_taxonomy_temp.txt','r',encoding='utf-8')
O6tt_lines = O6tt.readlines()
for O6tt_L in O6tt_lines:
    O6tt_N = str(O6tt_L)
    O6tt_NN = O6tt_N.split('	')
    O6tt_N1 = str(O6tt_NN[0])
    if O6tt_N1 != 'Feature ID' and O6tt_N1 != '#q2:types':
        merge_taxonomy6.writelines(O6tt_N)
        print(O6tt_N)
