## Import reference sequence (RefSeq1.fasta)
qiime tools import \
  --type 'FeatureData[Sequence]' \
  --input-path RefSeq1.fasta \
  --output-path ref-seq-fungi1.qza

## Import the classification information (utax1.txt)
qiime tools import \
  --type 'FeatureData[Taxonomy]' \
  --input-format HeaderlessTSVTaxonomyFormat \
  --input-path utax1.txt \
  --output-path ref-taxonomy-fungi1.qza

 ## Train classifier
 qiime feature-classifier fit-classifier-naive-bayes \
  --i-reference-reads ref-seq-fungi1.qza \
  --i-reference-taxonomy ref-taxonomy-fungi1.qza \
  --o-classifier classifier1.qza